UIPackage
Menu

Framework

Change language

Boilerplate repo

Anchor

anchor ui
Boilerplate repo

In-page navigation list with scroll-spy. Renders a vertical list of links; the active item highlights as the user scrolls through anchored sections.

Also available for React ->

Installation

$ npx shadcn-vue@latest add https://uipkge.dev/r/vue/anchor.json
Named registry: npx shadcn-vue@latest add @uipkge/anchor Installs to: app/components/ui/anchor/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
items AnchorItem[] () => [], offsetTop: 0, bounds: 5, scrollContainer: null,… optional
offsetTop number optional
bounds number optional
scrollContainer HTMLElement | string | null optional
affix boolean optional
class HTMLAttributes['class'] optional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

AnchorContext
interface AnchorContext {
  activeHref: Ref<string | null>
  setActive: (href: string) => void
  register: (href: string) => void
  unregister: (href: string) => void
  scrollContainer: Ref<HTMLElement | Window>
  offsetTop: Ref<number>
}
AnchorItem
interface AnchorItem {
  href: string
  title: string
  children?: AnchorItem[]
}

Files installed (4)

  • app/components/ui/anchor/Anchor.vue 4.1 kB
    <script setup lang="ts">
    import { onBeforeUnmount, onMounted, provide, ref, toRef, watch } from 'vue'
    import type { HTMLAttributes } from 'vue'
    import { cn } from '@/lib/utils'
    import type { AnchorItem } from '.'
    import { ANCHOR_INJECTION_KEY } from './context'
    import AnchorLink from './AnchorLink.vue'
    
    const props = withDefaults(
      defineProps<{
        items?: AnchorItem[]
        offsetTop?: number
        /**
         * Pixel leeway for the active-section band (top of the IntersectionObserver
         * rootMargin). Larger values activate a heading slightly earlier as you scroll.
         */
        bounds?: number
        scrollContainer?: HTMLElement | string | null
        affix?: boolean
        class?: HTMLAttributes['class']
      }>(),
      {
        items: () => [],
        offsetTop: 0,
        bounds: 5,
        scrollContainer: null,
        affix: false,
      },
    )
    
    const emits = defineEmits<{
      (e: 'change', href: string): void
    }>()
    
    const activeHref = ref<string | null>(null)
    const registered = ref<Set<string>>(new Set())
    const resolvedContainer = ref<HTMLElement | Window>(typeof window !== 'undefined' ? window : (null as any))
    
    function resolveContainer(): HTMLElement | Window {
      if (!props.scrollContainer) return window
      if (typeof props.scrollContainer === 'string') {
        return (document.querySelector(props.scrollContainer) as HTMLElement) ?? window
      }
      return props.scrollContainer
    }
    
    let observer: IntersectionObserver | null = null
    const observed = new Map<string, Element>()
    
    function rebuildObserver() {
      if (observer) {
        observer.disconnect()
        observed.clear()
      }
      const root = resolvedContainer.value === window ? null : (resolvedContainer.value as HTMLElement)
      observer = new IntersectionObserver(
        (entries) => {
          const intersecting = entries.filter((e) => e.isIntersecting)
          if (intersecting.length === 0) return
          intersecting.sort((a, b) => a.boundingClientRect.top - b.boundingClientRect.top)
          const id = '#' + intersecting[0]!.target.id
          if (id !== activeHref.value) {
            activeHref.value = id
            emits('change', id)
          }
        },
        {
          root,
          // bounds softens the top edge so a section can activate slightly before
          // its heading hits offsetTop exactly (ant-design-style leeway).
          rootMargin: `-${Math.max(0, props.offsetTop - props.bounds)}px 0px -60% 0px`,
          threshold: [0, 1],
        },
      )
      for (const href of registered.value) {
        const el = document.querySelector(href)
        if (el) {
          observed.set(href, el)
          observer.observe(el)
        }
      }
    }
    
    function setActive(href: string) {
      activeHref.value = href
      emits('change', href)
    }
    
    function register(href: string) {
      registered.value.add(href)
      if (!observer) return
      const el = document.querySelector(href)
      if (el && !observed.has(href)) {
        observed.set(href, el)
        observer.observe(el)
      }
    }
    
    function unregister(href: string) {
      registered.value.delete(href)
      const el = observed.get(href)
      if (el && observer) observer.unobserve(el)
      observed.delete(href)
    }
    
    provide(ANCHOR_INJECTION_KEY, {
      activeHref,
      setActive,
      register,
      unregister,
      scrollContainer: resolvedContainer,
      offsetTop: toRef(props, 'offsetTop'),
    })
    
    onMounted(() => {
      resolvedContainer.value = resolveContainer()
      rebuildObserver()
    })
    
    onBeforeUnmount(() => {
      observer?.disconnect()
      observer = null
    })
    
    watch(
      () => props.scrollContainer,
      () => {
        resolvedContainer.value = resolveContainer()
        rebuildObserver()
      },
    )
    
    watch(
      () => [props.offsetTop, props.bounds] as const,
      () => {
        rebuildObserver()
      },
    )
    </script>
    
    <template>
      <nav
        data-uipkge
        data-slot="anchor"
        aria-label="Table of contents"
        :class="cn('border-border flex flex-col gap-1 border-l text-sm', affix && 'sticky', props.class)"
        :style="affix ? { top: 'var(--anchor-offset-top, 0px)', '--anchor-offset-top': `${offsetTop}px` } : undefined"
      >
        <template v-if="items.length">
          <AnchorLink v-for="item in items" :key="item.href" :href="item.href" :title="item.title">
            <AnchorLink v-for="child in item.children ?? []" :key="child.href" :href="child.href" :title="child.title" />
          </AnchorLink>
        </template>
        <slot v-else />
      </nav>
    </template>
  • app/components/ui/anchor/AnchorLink.vue 2.1 kB
    <script setup lang="ts">
    import { computed, inject, onBeforeUnmount, onMounted, useSlots } from 'vue'
    import type { HTMLAttributes } from 'vue'
    import { cn } from '@/lib/utils'
    import { ANCHOR_INJECTION_KEY } from './context'
    
    const props = defineProps<{
      href: string
      title: string
      class?: HTMLAttributes['class']
    }>()
    
    const _maybeCtx = inject(ANCHOR_INJECTION_KEY, null)
    if (!_maybeCtx) throw new Error('AnchorLink must be used inside <Anchor>.')
    const ctx: NonNullable<typeof _maybeCtx> = _maybeCtx
    
    const isActive = computed(() => ctx.activeHref.value === props.href)
    const slots = useSlots()
    
    onMounted(() => ctx.register(props.href))
    onBeforeUnmount(() => ctx.unregister(props.href))
    
    function onClick(e: MouseEvent) {
      e.preventDefault()
      const el = document.querySelector(props.href) as HTMLElement | null
      if (!el) return
      const offset = ctx.offsetTop.value
      const container = ctx.scrollContainer.value
      const smooth = !window.matchMedia('(prefers-reduced-motion: reduce)').matches
      const behavior: ScrollBehavior = smooth ? 'smooth' : 'auto'
      if (container === window) {
        const top = el.getBoundingClientRect().top + window.scrollY - offset
        window.scrollTo({ top, behavior })
      } else {
        const c = container as HTMLElement
        const top = el.getBoundingClientRect().top - c.getBoundingClientRect().top + c.scrollTop - offset
        c.scrollTo({ top, behavior })
      }
      history.replaceState(null, '', props.href)
      ctx.setActive(props.href)
    }
    </script>
    
    <template>
      <div data-uipkge data-slot="anchor-link" class="flex flex-col">
        <a
          :href="href"
          :aria-current="isActive ? 'location' : undefined"
          :class="
            cn(
              'text-muted-foreground -ml-px block border-l-2 border-transparent py-2 pl-3 transition-colors',
              'hover:text-foreground',
              'focus-visible:ring-ring rounded-sm focus-visible:ring-2 focus-visible:ring-offset-2 focus-visible:outline-none',
              isActive && 'border-primary text-foreground font-medium',
              props.class,
            )
          "
          @click="onClick"
        >
          {{ title }}
        </a>
        <div v-if="slots.default" class="ml-3">
          <slot />
        </div>
      </div>
    </template>
  • app/components/ui/anchor/context.ts 0.4 kB
    import type { InjectionKey, Ref } from 'vue'
    
    export interface AnchorContext {
      activeHref: Ref<string | null>
      setActive: (href: string) => void
      register: (href: string) => void
      unregister: (href: string) => void
      scrollContainer: Ref<HTMLElement | Window>
      offsetTop: Ref<number>
    }
    
    export const ANCHOR_INJECTION_KEY: InjectionKey<AnchorContext> = Symbol('uipkge-anchor')
  • app/components/ui/anchor/index.ts 0.2 kB
    export interface AnchorItem {
      href: string
      title: string
      children?: AnchorItem[]
    }
    
    export { default as Anchor } from './Anchor.vue'
    export { default as AnchorLink } from './AnchorLink.vue'

Raw manifest: https://uipkge.dev/r/vue/anchor.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Anchor

anchor ui
Boilerplate repo

In-page navigation list with scroll-spy. Renders a vertical list of links; the active item highlights as the user scrolls through anchored sections.

Also available for Vue ->

Installation

$ npx shadcn@latest add https://uipkge.dev/r/react/anchor.json
Named registry: npx shadcn@latest add @uipkge-react/anchor Installs to: components/ui/anchor/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
items AnchorItem[] optional
offsetTop number 0 optional
bounds

Pixel leeway for the active-section band (top of the IntersectionObserver rootMargin). Larger values activate a heading slightly earlier as you scroll.

number 5 optional
scrollContainer HTMLElement | string | null optional
affix boolean false optional
onChange (href: string) => void optional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

AnchorItem
interface AnchorItem {
  href: string
  title: string
  children?: AnchorItem[]
}
AnchorContextValue
interface AnchorContextValue {
  activeHref: string | null
  setActive: (href: string) => void
  register: (href: string) => void
  unregister: (href: string) => void
  scrollContainerRef: React.MutableRefObject<HTMLElement | Window>
  offsetTopRef: React.MutableRefObject<number>
}

Files installed (2)

  • components/ui/anchor/anchor.tsx 7.9 kB
    'use client'
    
    import * as React from 'react'
    import { cn } from '@/lib/utils'
    
    export interface AnchorItem {
      href: string
      title: string
      children?: AnchorItem[]
    }
    
    interface AnchorContextValue {
      activeHref: string | null
      setActive: (href: string) => void
      register: (href: string) => void
      unregister: (href: string) => void
      scrollContainerRef: React.MutableRefObject<HTMLElement | Window>
      offsetTopRef: React.MutableRefObject<number>
    }
    
    const AnchorContext = React.createContext<AnchorContextValue | null>(null)
    
    export interface AnchorProps extends Omit<React.HTMLAttributes<HTMLElement>, 'onChange'> {
      items?: AnchorItem[]
      offsetTop?: number
      /**
       * Pixel leeway for the active-section band (top of the IntersectionObserver
       * rootMargin). Larger values activate a heading slightly earlier as you scroll.
       */
      bounds?: number
      scrollContainer?: HTMLElement | string | null
      affix?: boolean
      onChange?: (href: string) => void
    }
    
    const Anchor = React.forwardRef<HTMLElement, AnchorProps>(
      (
        {
          className,
          items = [],
          offsetTop = 0,
          bounds = 5,
          scrollContainer = null,
          affix = false,
          onChange,
          style,
          children,
          ...props
        },
        ref,
      ) => {
        const [activeHref, setActiveHref] = React.useState<string | null>(null)
        const activeHrefRef = React.useRef<string | null>(null)
        const registeredRef = React.useRef<Set<string>>(new Set())
        const observerRef = React.useRef<IntersectionObserver | null>(null)
        const observedRef = React.useRef<Map<string, Element>>(new Map())
        const scrollContainerRef = React.useRef<HTMLElement | Window>(
          typeof window !== 'undefined' ? window : (null as unknown as Window),
        )
        const offsetTopRef = React.useRef(offsetTop)
        const boundsRef = React.useRef(bounds)
        const onChangeRef = React.useRef(onChange)
    
        React.useEffect(() => {
          offsetTopRef.current = offsetTop
        }, [offsetTop])
        React.useEffect(() => {
          boundsRef.current = bounds
        }, [bounds])
        React.useEffect(() => {
          onChangeRef.current = onChange
        }, [onChange])
    
        const setActive = React.useCallback((href: string) => {
          activeHrefRef.current = href
          setActiveHref(href)
          onChangeRef.current?.(href)
        }, [])
    
        const resolveContainer = React.useCallback((): HTMLElement | Window => {
          if (!scrollContainer) return window
          if (typeof scrollContainer === 'string') {
            return (document.querySelector(scrollContainer) as HTMLElement) ?? window
          }
          return scrollContainer
        }, [scrollContainer])
    
        const rebuildObserver = React.useCallback(() => {
          if (observerRef.current) {
            observerRef.current.disconnect()
            observedRef.current.clear()
          }
          const container = scrollContainerRef.current
          const root = container === window ? null : (container as HTMLElement)
          observerRef.current = new IntersectionObserver(
            (entries) => {
              const intersecting = entries.filter((e) => e.isIntersecting)
              if (intersecting.length === 0) return
              intersecting.sort((a, b) => a.boundingClientRect.top - b.boundingClientRect.top)
              const id = '#' + intersecting[0]!.target.id
              if (id !== activeHrefRef.current) {
                activeHrefRef.current = id
                setActiveHref(id)
                onChangeRef.current?.(id)
              }
            },
            {
              root,
              // bounds softens the top edge so a section can activate slightly before
              // its heading hits offsetTop exactly (ant-design-style leeway).
              rootMargin: `-${Math.max(0, offsetTopRef.current - boundsRef.current)}px 0px -60% 0px`,
              threshold: [0, 1],
            },
          )
          for (const href of registeredRef.current) {
            const el = document.querySelector(href)
            if (el) {
              observedRef.current.set(href, el)
              observerRef.current.observe(el)
            }
          }
        }, [])
    
        const register = React.useCallback((href: string) => {
          registeredRef.current.add(href)
          if (!observerRef.current) return
          const el = document.querySelector(href)
          if (el && !observedRef.current.has(href)) {
            observedRef.current.set(href, el)
            observerRef.current.observe(el)
          }
        }, [])
    
        const unregister = React.useCallback((href: string) => {
          registeredRef.current.delete(href)
          const el = observedRef.current.get(href)
          if (el && observerRef.current) observerRef.current.unobserve(el)
          observedRef.current.delete(href)
        }, [])
    
        React.useEffect(() => {
          scrollContainerRef.current = resolveContainer()
          rebuildObserver()
          return () => {
            observerRef.current?.disconnect()
            observerRef.current = null
          }
          // eslint-disable-next-line react-hooks/exhaustive-deps
        }, [scrollContainer, offsetTop, bounds])
    
        const ctx = React.useMemo<AnchorContextValue>(
          () => ({ activeHref, setActive, register, unregister, scrollContainerRef, offsetTopRef }),
          [activeHref, setActive, register, unregister],
        )
    
        return (
          <AnchorContext.Provider value={ctx}>
            <nav
              ref={ref}
              data-uipkge=""
              data-slot="anchor"
              aria-label="Table of contents"
              className={cn('border-border flex flex-col gap-1 border-l text-sm', affix && 'sticky', className)}
              style={affix ? { top: `${offsetTop}px`, ...style } : style}
              {...props}
            >
              {items.length
                ? items.map((item) => (
                    <AnchorLink key={item.href} href={item.href} title={item.title}>
                      {(item.children ?? []).map((child) => (
                        <AnchorLink key={child.href} href={child.href} title={child.title} />
                      ))}
                    </AnchorLink>
                  ))
                : children}
            </nav>
          </AnchorContext.Provider>
        )
      },
    )
    Anchor.displayName = 'Anchor'
    
    export interface AnchorLinkProps {
      href: string
      title: string
      className?: string
      children?: React.ReactNode
    }
    
    const AnchorLink = React.forwardRef<HTMLDivElement, AnchorLinkProps>(({ href, title, className, children }, ref) => {
      const ctx = React.useContext(AnchorContext)
      if (!ctx) throw new Error('AnchorLink must be used inside <Anchor>.')
    
      const isActive = ctx.activeHref === href
    
      React.useEffect(() => {
        ctx.register(href)
        return () => ctx.unregister(href)
        // eslint-disable-next-line react-hooks/exhaustive-deps
      }, [href])
    
      const onClick = (e: React.MouseEvent) => {
        e.preventDefault()
        const el = document.querySelector(href) as HTMLElement | null
        if (!el) return
        const offset = ctx.offsetTopRef.current
        const container = ctx.scrollContainerRef.current
        const smooth = !window.matchMedia('(prefers-reduced-motion: reduce)').matches
        const behavior: ScrollBehavior = smooth ? 'smooth' : 'auto'
        if (container === window) {
          const top = el.getBoundingClientRect().top + window.scrollY - offset
          window.scrollTo({ top, behavior })
        } else {
          const c = container as HTMLElement
          const top = el.getBoundingClientRect().top - c.getBoundingClientRect().top + c.scrollTop - offset
          c.scrollTo({ top, behavior })
        }
        history.replaceState(null, '', href)
        ctx.setActive(href)
      }
    
      return (
        <div ref={ref} data-uipkge="" data-slot="anchor-link" className="flex flex-col">
          <a
            href={href}
            aria-current={isActive ? 'location' : undefined}
            className={cn(
              'text-muted-foreground -ml-px block border-l-2 border-transparent py-2 pl-3 transition-colors',
              'hover:text-foreground',
              'focus-visible:ring-ring rounded-sm focus-visible:ring-2 focus-visible:ring-offset-2 focus-visible:outline-none',
              isActive && 'border-primary text-foreground font-medium',
              className,
            )}
            onClick={onClick}
          >
            {title}
          </a>
          {children ? <div className="ml-3">{children}</div> : null}
        </div>
      )
    })
    AnchorLink.displayName = 'AnchorLink'
    
    export { Anchor, AnchorLink }
  • components/ui/anchor/index.ts 0.1 kB
    export { Anchor, AnchorLink, type AnchorItem, type AnchorProps, type AnchorLinkProps } from './anchor'

Raw manifest: https://uipkge.dev/r/react/anchor.json